/*
 * Copyright (c) 1980 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 * This module is believed to contain source code proprietary to AT&T.
 * Use and redistribution is subject to the Berkeley Software License
 * Agreement and your Software Agreement with AT&T (Western Electric).
 *
 *	from ex_tune.h	7.8.1 (2.11BSD) 1996/10/23
 *
 *	@(#)ex_tune.h	1.7 (gritter) 11/8/00
 */

/*
 * Note: the parameters that are actually tuneable have been moved to
 * config.h. Do not make changes here unless you know what you are
 * doing! GR
 */

/*
 * Definitions of editor parameters and limits
 */

/*
 * Pathnames (will be predefined in Makefile).
 */
#ifndef	EXRECOVER
#define	EXRECOVER	"/usr/sbin/exrecover"
#endif
#ifndef	EXPRESERVE
#define	EXPRESERVE	"/usr/sbin/expreserve"
#endif
#ifndef VMUNIX
#ifndef	EXSTRINGS
#define	EXSTRINGS	"/usr/share/misc/exstrings"
#endif
#endif

/*
 * If your system believes that tabs expand to a width other than
 * 8 then your makefile should cc with -DTABS=whatever, otherwise we use 8.
 */
#ifndef TABS
#define	TABS	8
#endif

/*
 * Maximums
 *
 * The definition of LBSIZE should be the same as BUFSIZ (512 usually).
 * Most other definitions are quite generous.
 */
/* FNSIZE is also defined in expreserve.c */
#ifdef	_POSIX_PATH_MAX
#define	FNSIZE		_POSIX_PATH_MAX
#else
#define	FNSIZE		128		/* File name size */
#endif
#ifdef VMUNIX
#define	LBSIZE		BUFSIZ		/* Line buffer size */
#define	ESIZE		512		/* Regular expression buffer size */
#define CRSIZE		BUFSIZ		/* Crypt buffer size */
#else	/* !VMUNIX */
#ifdef u370
#define LBSIZE		4096
#define ESIZE		512
#define CRSIZE		4096
#else
#define	LBSIZE		512		/* Line length */
#define	ESIZE		128		/* Size of compiled re */
#define CRSIZE		512
#endif
#endif
#define	RHSSIZE		256		/* Size of rhs of substitute */
#define	NBRA		9		/* Number of re \( \) pairs */
#define	TAGSIZE		128		/* Tag length */
#define	ONMSZ		64		/* Option name size */
#define	GBSIZE		256		/* Buffer size */
#define	UXBSIZE		128		/* Unix command buffer size */
#define	VBSIZE		128		/* Partial line max size in visual */
/* LBLKS is also defined in expreserve.c */
#ifndef VMUNIX
#define	LBLKS		125		/* Line pointer blocks in temp file */
#define	HBLKS		1		/* struct header fits in BUFSIZ*HBLKS */
#else	/* VMUNIX */
#ifdef	LARGEF
#define	LBLKS		20000
#else	/* !LARGEF */
#define	LBLKS		900
#endif	/* !LARGEF */
#define	HBLKS		(1 + (FNSIZE + LBLKS * sizeof(bloc)) / BUFSIZ)
#endif	/* VMUNIX */
#define	MAXDIRT		12		/* Max dirtcnt before sync tfile */

/*
 * Size of in-core buffers for temporary file. Since this is
 * sizeof (char) * (INCORB + 1) * BUFSIZ, it should not be too
 * large.
 *
 * If not defined, no in-core buffers are used.
 */
#ifdef	VMUNIX
#if	(BUFSIZ - 0) <= 16384
#define	INCORB		(65536/BUFSIZ)
#else	/* Huge-memory systems. */
#define	INCORB		4
#endif	/* Huge-memory systems. */
#endif	/* VMUNIX */

/*
 * Except on VMUNIX, these are a ridiculously small due to the
 * lousy arglist processing implementation which fixes core
 * proportional to them.  Argv (and hence NARGS) is really unnecessary,
 * and argument character space not needed except when
 * arguments exist.  Argument lists should be saved before the "zero"
 * of the incore line information and could then
 * be reasonably large.
 */
#undef NCARGS
#ifndef VMUNIX
#define	NARGS	100		/* Maximum number of names in "next" */
#define	NCARGS	LBSIZE		/* Maximum arglist chars in "next" */
#else
#define	NCARGS	5120
#define	NARGS	(NCARGS/6)
#endif

/*
 * Output column (and line) are set to this value on cursor addressible
 * terminals when we lose track of the cursor to force cursor
 * addressing to occur.
 */
#define	UKCOL		-20	/* Prototype unknown column */

/*
 * Attention is the interrupt character (normally 0177 -- delete).
 * Quit is the quit signal (normally FS -- control-\) and quits open/visual.
 */
#ifndef	BIT8
#define	ATTN	(-2)	/* mjm: (char) ??  */
#else
#define	ATTN	DELETE
#endif
#define	QUIT	('\\' & 037)
